poj3126 Prime Path(素数路径)

来源:互联网 发布:unity3d房子模型 编辑:程序博客网 时间:2024/05/25 19:57

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
31033 81791373 80171033 1033
Sample Output
670

#include <iostream>#include <cmath>#include <queue>#include <cstring>using namespace std;const int maxn=100000;int prime[maxn]={0};int vis[maxn];//等于1的是质数 void pre(){prime[0]=prime[1]=1;for(int i=2;i<=sqrt(maxn)+1;i++){if(!prime[i])for(int j=i*i;j<=maxn;j+=i)prime[j]=1;}}int a,b; typedef class{public:int x;int step;}node;int dfs(){node pre,nxt;queue<node>q;pre.x=a;pre.step=0;vis[a]=1;q.push(pre);while(!q.empty()){pre=q.front();q.pop();if(pre.x==b){return pre.step;}int w1,w2,w3,w4;w1=pre.x/1000;w2=pre.x/100-w1*10;w3=pre.x/10-w1*100-w2*10;w4=pre.x%10;//cout<<w1<<" "<<w2<<" "<<w3<<" "<<w4<<endl;//第一位int tempx;for(int i=1;i<10;i++){tempx=i*1000+w2*100+w3*10+w4;if(!vis[tempx]&&!prime[tempx]){nxt.x=tempx;nxt.step=pre.step+1;q.push(nxt);vis[tempx]=1;//cout<<nxt.x<<"  "<<nxt.step<<endl;}}//第二位for(int i=0;i<10;i++){tempx=w1*1000+i*100+w3*10+w4;if(!vis[tempx]&&!prime[tempx]){nxt.x=tempx;nxt.step=pre.step+1;q.push(nxt);vis[tempx]=1;//cout<<nxt.x<<"  "<<nxt.step<<endl;}}//第三位for(int i=0;i<10;i++){tempx=w1*1000+w2*100+i*10+w4;if(!vis[tempx]&&!prime[tempx]){nxt.x=tempx;nxt.step=pre.step+1;q.push(nxt);vis[tempx]=1;///cout<<nxt.x<<"  "<<nxt.step<<endl;}}//第四位 for(int i=0;i<10;i++){tempx=w1*1000+w2*100+w3*10+i;if(!vis[tempx]&&!prime[tempx]){nxt.x=tempx;nxt.step=pre.step+1;q.push(nxt);vis[tempx]=1;//cout<<nxt.x<<"  "<<nxt.step<<endl;}}}return -1;}int main(){ios::sync_with_stdio(false);pre();int ncase;cin>>ncase;while(ncase--){cin>>a>>b;memset(vis,0,sizeof vis);int res=dfs();if(res<0)cout<<"Impossible"<<endl;elsecout<<res<<endl;}return 0;}